import { TokenType } from 'chevrotain';
export interface TokenVocabulary {
    [vocab: string]: TokenType;
}
export declare const ReservedKeyword: TokenType;
export declare const Keyword: TokenType;
export declare const DateFunction: TokenType;
export declare const AggregateFunction: TokenType;
export declare const LocationFunction: TokenType;
export declare const FieldsFunction: TokenType;
export declare const FieldsFunctionParamIdentifier: TokenType;
export declare const OtherFunction: TokenType;
export declare const DateLiteral: TokenType;
export declare const DateLiteralNotIdentifier: TokenType;
export declare const DateNLiteral: TokenType;
export declare const RelationalOperator: TokenType;
export declare const SymbolIdentifier: TokenType;
export declare const DateIdentifier: TokenType;
export declare const NumberIdentifier: TokenType;
export declare const DecimalNumberIdentifier: TokenType;
export declare const IntegerNumberIdentifier: TokenType;
export declare const IdentifierNotKeyword: TokenType;
export declare const UsingScopeEnumeration: TokenType;
export declare const RParenMismatch: TokenType;
export declare const Identifier: TokenType;
export declare const StringIdentifier: TokenType;
export declare const WhiteSpace: TokenType;
export declare const And: TokenType;
export declare const As: TokenType;
export declare const Desc: TokenType;
export declare const Asc: TokenType;
export declare const OrderBy: TokenType;
export declare const Cube: TokenType;
export declare const Else: TokenType;
export declare const Excludes: TokenType;
export declare const False: TokenType;
export declare const First: TokenType;
export declare const From: TokenType;
export declare const GroupBy: TokenType;
export declare const Having: TokenType;
export declare const In: TokenType;
export declare const NotIn: TokenType;
export declare const Includes: TokenType;
export declare const Last: TokenType;
export declare const Like: TokenType;
export declare const Limit: TokenType;
export declare const Not: TokenType;
export declare const Null: TokenType;
export declare const Nulls: TokenType;
export declare const Or: TokenType;
export declare const Rollup: TokenType;
export declare const Select: TokenType;
export declare const True: TokenType;
export declare const Using: TokenType;
export declare const Where: TokenType;
export declare const With: TokenType;
export declare const For: TokenType;
export declare const Update: TokenType;
export declare const Above: TokenType;
export declare const AboveOrBelow: TokenType;
export declare const ApexNew: TokenType;
export declare const At: TokenType;
export declare const Below: TokenType;
export declare const DataCategory: TokenType;
export declare const End: TokenType;
export declare const Offset: TokenType;
export declare const Reference: TokenType;
export declare const Scope: TokenType;
export declare const Tracking: TokenType;
export declare const Then: TokenType;
export declare const Typeof: TokenType;
export declare const View: TokenType;
export declare const Viewstat: TokenType;
export declare const When: TokenType;
export declare const SecurityEnforced: TokenType;
export declare const SystemMode: TokenType;
export declare const UserMode: TokenType;
export declare const CalendarMonth: TokenType;
export declare const CalendarQuarter: TokenType;
export declare const CalendarYear: TokenType;
export declare const DayInMonth: TokenType;
export declare const DayInWeek: TokenType;
export declare const DayInYear: TokenType;
export declare const DayOnly: TokenType;
export declare const FiscalMonth: TokenType;
export declare const FiscalQuarter: TokenType;
export declare const FiscalYear: TokenType;
export declare const HourInDay: TokenType;
export declare const WeekInMonth: TokenType;
export declare const WeekInYear: TokenType;
export declare const Avg: TokenType;
export declare const Count: TokenType;
export declare const CountDistinct: TokenType;
export declare const Min: TokenType;
export declare const Max: TokenType;
export declare const Sum: TokenType;
export declare const Distance: TokenType;
export declare const Geolocation: TokenType;
export declare const Fields: TokenType;
export declare const Format: TokenType;
export declare const Tolabel: TokenType;
export declare const ConvertTimeZone: TokenType;
export declare const ConvertCurrency: TokenType;
export declare const Grouping: TokenType;
export declare const All: TokenType;
export declare const Custom: TokenType;
export declare const Standard: TokenType;
export declare const Yesterday: TokenType;
export declare const Today: TokenType;
export declare const Tomorrow: TokenType;
export declare const LastWeek: TokenType;
export declare const ThisWeek: TokenType;
export declare const NextWeek: TokenType;
export declare const LastMonth: TokenType;
export declare const ThisMonth: TokenType;
export declare const NextMonth: TokenType;
export declare const Last90_days: TokenType;
export declare const Next90_days: TokenType;
export declare const ThisQuarter: TokenType;
export declare const LastQuarter: TokenType;
export declare const NextQuarter: TokenType;
export declare const ThisYear: TokenType;
export declare const LastYear: TokenType;
export declare const NextYear: TokenType;
export declare const ThisFiscalQuarter: TokenType;
export declare const LastFiscalQuarter: TokenType;
export declare const NextFiscalQuarter: TokenType;
export declare const ThisFiscalYear: TokenType;
export declare const LastFiscalYear: TokenType;
export declare const NextFiscalYear: TokenType;
export declare const NextNDays: TokenType;
export declare const LastNDays: TokenType;
export declare const NDaysAgo: TokenType;
export declare const NextNWeeks: TokenType;
export declare const LastNWeeks: TokenType;
export declare const NWeeksAgo: TokenType;
export declare const NextNMonths: TokenType;
export declare const LastNMonths: TokenType;
export declare const NMonthsAgo: TokenType;
export declare const NextNQuarters: TokenType;
export declare const LastNQuarters: TokenType;
export declare const NQuartersAgo: TokenType;
export declare const NextNYears: TokenType;
export declare const LastNYears: TokenType;
export declare const NYearsAgo: TokenType;
export declare const NextNFiscalQuarters: TokenType;
export declare const LastNFiscalQuarters: TokenType;
export declare const NFiscalQuartersAgo: TokenType;
export declare const NextNFiscalYears: TokenType;
export declare const LastNFiscalYears: TokenType;
export declare const NFiscalYearsAgo: TokenType;
export declare const Equal: TokenType;
export declare const NotEqual: TokenType;
export declare const LessThan: TokenType;
export declare const LessThanOrEqual: TokenType;
export declare const GreaterThan: TokenType;
export declare const GreaterThanOrEqual: TokenType;
export declare const Decimal: TokenType;
export declare const Colon: TokenType;
export declare const Semicolon: TokenType;
export declare const Comma: TokenType;
export declare const Asterisk: TokenType;
export declare const LParen: TokenType;
export declare const RParen: TokenType;
export declare const LSquareBracket: TokenType;
export declare const RSquareBracket: TokenType;
export declare const Plus: TokenType;
export declare const Minus: TokenType;
export declare const DateTime: TokenType;
export declare const DateToken: TokenType;
export declare const CurrencyPrefixedDecimal: TokenType;
export declare const SignedDecimal: TokenType;
export declare const UnsignedDecimal: TokenType;
export declare const CurrencyPrefixedInteger: TokenType;
export declare const SignedInteger: TokenType;
export declare const GeolocationUnit: TokenType;
export declare const UnsignedInteger: TokenType;
export declare const Delegated: TokenType;
export declare const Everything: TokenType;
export declare const MineAndMyGroups: TokenType;
export declare const Mine: TokenType;
export declare const MyTerritory: TokenType;
export declare const MyTeamTerritory: TokenType;
export declare const Team: TokenType;
export declare const AllPrivate: TokenType;
export declare const allTokens: TokenType[];
export declare function lex(soql: string): import("chevrotain").ILexingResult;
