import { CstNode, CstParser, IRecognitionException } from 'chevrotain';
export interface ParseQueryConfig {
    allowPartialQuery?: boolean;
    allowApexBindVariables?: boolean;
    ignoreParseErrors?: boolean;
    logErrors?: boolean;
}
declare class ParsingError extends Error {
    constructor(parsingError: IRecognitionException);
}
export declare class SoqlParser extends CstParser {
    private $_dateFunctionOr;
    private $_aggregateFunction;
    private $_otherFunction;
    private $_atomicExpression;
    private $_apexBindVariableExpression;
    private $_arrayExpression;
    private $_relationalOperator;
    private $_selectClause;
    private $_selectClauseFunctionIdentifier;
    private $_withDataCategoryArr;
    allowApexBindVariables: boolean;
    ignoreParseErrors: boolean;
    constructor({ ignoreParseErrors }?: {
        ignoreParseErrors: boolean;
    });
    selectStatement: (idxInCallingRule?: number, ...args: any[]) => CstNode;
    selectStatementPartial: (idxInCallingRule?: number, ...args: any[]) => CstNode;
    clauseStatements: (idxInCallingRule?: number, ...args: any[]) => CstNode;
    private $_checkBalancedParens;
    private selectClause;
    private selectClauseFunctionIdentifier;
    private selectClauseSubqueryIdentifier;
    private selectClauseTypeOf;
    private selectClauseIdentifier;
    private selectClauseTypeOfThen;
    private selectClauseTypeOfElse;
    private fromClause;
    private usingScopeClause;
    private whereClause;
    private whereClauseSubqueryIdentifier;
    private conditionExpression;
    private withClause;
    private withDataCategory;
    private withDataCategoryArr;
    private groupByClause;
    private havingClause;
    private orderByClause;
    private orderByExpression;
    private orderByGroupingFunctionExpression;
    private orderBySpecialFunctionExpression;
    private limitClause;
    private offsetClause;
    private dateFunction;
    private aggregateFunction;
    private fieldsFunction;
    private otherFunction;
    private cubeFunction;
    private rollupFunction;
    private functionExpression;
    private locationFunction;
    private geolocationFunction;
    private expressionPartWithNegation;
    private expression;
    private expressionWithRelationalOperator;
    private expressionWithSetOperator;
    private atomicExpression;
    private apexBindVariableExpression;
    private apexBindVariableIdentifier;
    private apexBindVariableNewInstantiation;
    private apexBindVariableFunctionCall;
    private apexBindVariableGeneric;
    private apexBindVariableFunctionParams;
    private apexBindVariableFunctionArrayAccessor;
    private arrayExpression;
    private relationalOperator;
    private setOperator;
    private booleanValue;
    private dateNLiteral;
    private forViewOrReference;
    private updateTrackingViewstat;
    private getParenCount;
}
export declare function parse(soql: string, options?: ParseQueryConfig): {
    cst: CstNode;
    parseErrors: ParsingError[];
};
export {};
